%
% z=invdiff(w)
%
% This function computes the inverse of the backwards diff operator.  
%
function z=invdiff(w)
%
%  Since w(n)=z(n)-z(n-1), z(n)=z(n-1)+w(n).  We initialize with z(1)=w(1). 
%
z=zeros(size(w));
z(1)=w(1);
for i=2:length(w),
  z(i)=z(i-1)+w(i);
end;
