%
% phihat=pacf(r,n)
%
% Uses the Durbin recursive formulas to estimate the PACF coefficients.  
%  
function phihat=pacf(myr,n)
phihat=zeros(n,n);
phihat(1,1)=myr(1);
for p=1:n-1,
  num=myr(p+1);
  for j=1:p,
    num=num-phihat(p,j)*myr(p+1-j);
  end;
  denom=1;
  for j=1:p,
    denom=denom-phihat(p,j)*myr(j);
  end;
  phihat(p+1,p+1)=num/denom;
  for j=1:p,
    phihat(p+1,j)=phihat(p,j)-phihat(p+1,p+1)*phihat(p,p-j+1);
  end;
end;
