%  [a0,a,b,p]=pgram(z)
%
%  Computes the periodogram of a time series.
%
function [a0,a,b,p]=pgram(z)
n=length(z);
q=floor(n/2);
%
% a0 is always zbar.
%
a0=mean(z);
if (mod(n,2) == 1),
%
% n odd.
%
   a=zeros(q,1);
   b=zeros(q,1);
   for i=1:q,
      for t=1:n,
         a(i)=a(i)+z(t)*cos(2*pi*i*t/n);
         b(i)=b(i)+z(t)*sin(2*pi*i*t/n);
      end;
      a(i)=2*a(i)/n;
      b(i)=2*b(i)/n;
   end;
   for i=1:q,
      p(i)=n*(a(i)^2+b(i)^2)/2;
   end;
else
%
% n even
%
   a=zeros(q,1);
   b=zeros(q,1);
   for i=1:q-1,
      for t=1:n,
         a(i)=a(i)+z(t)*cos(2*pi*i*t/n);
         b(i)=b(i)+z(t)*sin(2*pi*i*t/n);
      end;
      a(i)=2*a(i)/n;
      b(i)=2*b(i)/n;
   end;
   for i=1:q-1,
      p(i)=n*(a(i)^2+b(i)^2)/2;
   end;
   for t=1:n,
      a(q)=a(q)+(-1)^t*z(t);
   end;
   a(q)=a(q)/n;
   b(q)=0;
   p(q)=n*a(q)*a(q);
end;
