%
%  I=spec(z,f)
%
% Computes the sample spectrum of z at frequency f, 0<=f<=1/2.
%
function I=spec(z,f)
n=length(z);
af=0;
bf=0;
for j=1:n,
  af=af+z(j)*cos(2 *pi*f*j);
  bf=bf+z(j)*sin(2*pi*f*j);
end;
af=2*af/n;
bf=2*bf/n;
I=n*(af^2+bf^2)/2;
    
